/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the StorageSourceMeta type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &StorageSourceMeta{}

// StorageSourceMeta struct for StorageSourceMeta
type StorageSourceMeta struct {
	//
	Id     *string          `json:"id,omitempty"`
	Engine *SourceEngineDTO `json:"engine,omitempty"`
	//
	Columns []SourceColumnDTO `json:"columns,omitempty"`
}

// NewStorageSourceMeta instantiates a new StorageSourceMeta object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewStorageSourceMeta() *StorageSourceMeta {
	this := StorageSourceMeta{}
	return &this
}

// NewStorageSourceMetaWithDefaults instantiates a new StorageSourceMeta object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewStorageSourceMetaWithDefaults() *StorageSourceMeta {
	this := StorageSourceMeta{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *StorageSourceMeta) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StorageSourceMeta) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *StorageSourceMeta) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *StorageSourceMeta) SetId(v string) {
	o.Id = &v
}

// GetEngine returns the Engine field value if set, zero value otherwise.
func (o *StorageSourceMeta) GetEngine() SourceEngineDTO {
	if o == nil || IsNil(o.Engine) {
		var ret SourceEngineDTO
		return ret
	}
	return *o.Engine
}

// GetEngineOk returns a tuple with the Engine field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StorageSourceMeta) GetEngineOk() (*SourceEngineDTO, bool) {
	if o == nil || IsNil(o.Engine) {
		return nil, false
	}
	return o.Engine, true
}

// HasEngine returns a boolean if a field has been set.
func (o *StorageSourceMeta) HasEngine() bool {
	if o != nil && !IsNil(o.Engine) {
		return true
	}

	return false
}

// SetEngine gets a reference to the given SourceEngineDTO and assigns it to the Engine field.
func (o *StorageSourceMeta) SetEngine(v SourceEngineDTO) {
	o.Engine = &v
}

// GetColumns returns the Columns field value if set, zero value otherwise.
func (o *StorageSourceMeta) GetColumns() []SourceColumnDTO {
	if o == nil || IsNil(o.Columns) {
		var ret []SourceColumnDTO
		return ret
	}
	return o.Columns
}

// GetColumnsOk returns a tuple with the Columns field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StorageSourceMeta) GetColumnsOk() ([]SourceColumnDTO, bool) {
	if o == nil || IsNil(o.Columns) {
		return nil, false
	}
	return o.Columns, true
}

// HasColumns returns a boolean if a field has been set.
func (o *StorageSourceMeta) HasColumns() bool {
	if o != nil && !IsNil(o.Columns) {
		return true
	}

	return false
}

// SetColumns gets a reference to the given []SourceColumnDTO and assigns it to the Columns field.
func (o *StorageSourceMeta) SetColumns(v []SourceColumnDTO) {
	o.Columns = v
}

func (o StorageSourceMeta) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o StorageSourceMeta) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Engine) {
		toSerialize["engine"] = o.Engine
	}
	if !IsNil(o.Columns) {
		toSerialize["columns"] = o.Columns
	}
	return toSerialize, nil
}

type NullableStorageSourceMeta struct {
	value *StorageSourceMeta
	isSet bool
}

func (v NullableStorageSourceMeta) Get() *StorageSourceMeta {
	return v.value
}

func (v *NullableStorageSourceMeta) Set(val *StorageSourceMeta) {
	v.value = val
	v.isSet = true
}

func (v NullableStorageSourceMeta) IsSet() bool {
	return v.isSet
}

func (v *NullableStorageSourceMeta) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStorageSourceMeta(val *StorageSourceMeta) *NullableStorageSourceMeta {
	return &NullableStorageSourceMeta{value: val, isSet: true}
}

func (v NullableStorageSourceMeta) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStorageSourceMeta) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
